当前位置:首页 > 开发 > Web前端 > HTML > 正文

html判断IE版本

发表于: 2012-08-23   作者:商人shang   来源:转载   浏览:
摘要: [html] view plain copy 1.<!--[if!IE]><!-->除IE外都可识别<!--<![endif]--> 2.<!--[ifIE]>所有的IE可识别<![endif]--> 3.<!--[ifIE5.0]>只有IE5.0可以识别<![endif]--
[html] view plain copy
  1. 1.<!--[if!IE]><!-->除IE外都可识别<!--<![endif]-->
  2. 2.<!--[ifIE]>所有的IE可识别<![endif]-->
  3. 3.<!--[ifIE5.0]>只有IE5.0可以识别<![endif]-->
  4. 4.<!--[ifIE5]>仅IE5.0与IE5.5可以识别<![endif]-->
  5. 5.<!--[ifgtIE5.0]>IE5.0以及IE5.0以上版本都可以识别<![endif]-->
  6. 6.<!--[ifIE6]>仅IE6可识别<![endif]-->
  7. 7.<!--[ifltIE6]>IE6以及IE6以下版本可识别<![endif]-->
  8. 8.<!--[ifgteIE6]>IE6以及IE6以上版本可识别<![endif]-->
  9. 9.<!--[ifIE7]>仅IE7可识别<![endif]-->
  10. 10.<!--[ifltIE7]>IE7以及IE7以下版本可识别<![endif]-->
  11. 11.<!--[ifgteIE7]>IE7以及IE7以上版本可识别<![endif]-->

<!--[if lte IE 6]>……<![endif]-->

Ite:less than or equal to意思是小于或等于IE6浏览器,用于IE浏览器的条件注释,常用于CSShack,针对IE的JS等。

在进行WEB标准网页的学习和应用过程中,网页对浏览器的兼容性是经常接触到的一个问题。其中因微软公司的Internet Explorer(简称IE)占据浏览器市场的大半江山,此外还有Firefox、Opera等。需要对这些浏览器进行兼容。

同时,单就IE而言,因IE版本的升级更替,目前浏览者使用的主要停留在 IE5(IE5.5)、IE6和IE7这三个版本中。而这3个版本对于我们制作的WEB标准网页(XHTML+CSS)解释执行的显示状况不尽相同。并且,其他非IE浏览器与IE对某些CSS解释也不一样。所以,通过IE浏览器中的专有条件注释可有针对性的进行相关属性的定义。

条件注释只能用于Explorer 5+ Windows(以下简称IE)(条件注释从IE5开始被支持)。如果你安装了多个IE,条件注释(Conditional comments)将会以最高版本的IE为标准(目前为IE 7)。

条件注释只能在windows Internet Explorer(以下简称IE)下使用,因此我们可以通过条件注释来为IE添加特别的指令。

通俗点,条件注释就是一些if判断,但这些判断不是在脚本里执行的,而是直接在html代码里执行的,比如:

[html] view plain copy
  1. <!--[ifIE]>这里是正常的html代码<![endif]-->
  1. 条件注释的基本结构和HTML的注释(<!-- -->)是一样的。因此IE以外的浏览器将会把它们看作是普通的注释而完全忽略它们。
  2. IE将会根据if条件来判断是否如解析普通的页面内容一样解析条件注释里的内容。
  3. 条件注释使用的是HTML的注释结构,因此他们只能使用在HTML文件里,而不能在CSS文件中使用。

可使用如下代码检测当前IE浏览器的版本(注意:在非IE浏览器中是看不到效果的)

[html] view plain copy
  1. <!--[ifIE]>
  2. <h1>您正在使用IE浏览器</h1>
  3. <!--[ifIE5]>
  4. <h2>版本5</h2>
  5. <![endif]-->
  6. <!--[ifIE5.0]>
  7. <h2>版本5.0</h2>
  8. <![endif]-->
  9. <!--[ifIE5.5]>
  10. <h2>版本5.5</h2>
  11. <![endif]-->
  12. <!--[ifIE6]>
  13. <h2>版本6</h2>
  14. <![endif]-->
  15. <!--[ifIE7]>
  16. <h2>版本7</h2>
  17. <![endif]-->
  18. <![endif]-->

那如果当前的浏览器是IE,但版本比IE5还低,该怎么办呢,可以使用<!--[if ls IE 5]>,当然,根据条件注释只能在IE5+的环境之下,所以<!--[if ls IE 5]>根本不会被执行。

  • lte:就是Less than or equal to的简写,也就是小于或等于的意思。
  • lt :就是Less than的简写,也就是小于的意思。
  • gte:就是Greater than or equal to的简写,也就是大于或等于的意思。
  • gt :就是Greater than的简写,也就是大于的意思。
  • ! :就是不等于的意思,跟javascript里的不等于判断符相同

Conditional comments属于CSS hack? 条件判断属于CSS hack吗?

严格地说是属于CSS hack。因为就好象其他真正的css hack一样,它使得我们可以给一些浏览器赋予特殊的样式,再则它不依赖于某个浏览器的BUG来控制另外一个浏览器(的样式)。除此之外,条件判断还能用来做一些超出CSS HACK范围的事情(虽然这种情况很少发生)。

因为条件判断不依赖于某个浏览器的hack,而是一个经过深思熟虑的特色功能,所以我相信它是可以被放心地使用的。当然,其他浏览器也有可能支持条件判断(到目前为止还没有),但是看起来,他们应该不会使用如<!--[if IE]>这样的语法。

 

应该如何应用条件注释

本文一开始就说明了,因为IE各版本的浏览器对我们制作的WEB标准的页面解释不一样,具体就是对CSS的解释不同,我们为了兼容这些,可运用条件注释来各自定义,最终达到兼容的目的。比如:

[html] view plain copy
  1. <!--默认先调用css.css样式表-->
  2. <linkrel="stylesheet"type="text/css"href="css.css"/>
  3. <!--[ifIE7]>
  4. <!--如果IE浏览器版是7,调用ie7.css样式表-->
  5. <linkrel="stylesheet"type="text/css"href="ie7.css"/>
  6. <![endif]-->
  7. <!--[iflteIE6]>
  8. <!--如果IE浏览器版本小于等于6,调用ie.css样式表-->
  9. <linkrel="stylesheet"type="text/css"href="ie.css"/>
  10. <![endif]-->

这其中就区分了IE7和IE6向下的浏览器对CSS的执行,达到兼容的目的。同时,首行默认的css.css还能与其他非IE浏览器实现兼容。

注意:默认的CSS样式应该位于HTML文档的首行,进行条件注释判断的所有内容必须位于该默认样式之后。

比如如下代码,在IE浏览器下执行显示为红色,而在非IE浏览器下显示为黑色。如果把条件注释判断放在首行,则不能实现。该例题很能说明网页对IE浏览器和非IE浏览器间的兼容性问题解决。

[html] view plain copy
  1. <styletype="text/css">
  2. body{
  3. background-color:#000;
  4. }
  5. </style>
  6. <!--[ifIE]>
  7. <styletype="text/css">
  8. body{
  9. background-color:#F00;
  10. }
  11. </style>
  12. <![endif]-->

同时,有人会试图使用<!--[if !IE]>来定义非IE浏览器下的状况,但注意:条件注释只有在IE浏览器下才能执行,这个代码在非IE浏览下非单不是执行该条件下的定义,而是当做注释视而不见。

正常就是默认的样式,对IE浏览器需要特殊处理的,才进行条件注释。

在HTML文件里,而不能在CSS文件中使用。

 

 

转自:http://blog.csdn.net/zhengzhb/article/details/7666050

html判断IE版本

  • 0

    开心

    开心

  • 0

    板砖

    板砖

  • 0

    感动

    感动

  • 0

    有用

    有用

  • 0

    疑问

    疑问

  • 0

    难过

    难过

  • 0

    无聊

    无聊

  • 0

    震惊

    震惊

编辑推荐
web开发就不得不面对浏览器兼容性问题,特别是IE的兼容问题。在前端代码中经常要处理一些兼容格式,
项目已接近尾声,本来是存java程序员,奈何公司没有美工,所以得自己写css。这里把项目中IE不同版本
刚刚得知,IE9的beta版本已经上市,立刻下载试用。安装相对以前版本也比较容易,连繁琐的下一步下一
同事做测试的,介绍了一个ietester来用,很不错,在这里分享下。 ietester,包括各个版本的IE。 可以
<html> <head> <title>css样式设置</title> <style> body { width:9
原文: http://www.abigdreamer.com/index.php/archives/26 /** * @class Browser 判断浏览器类型和
原文: http://www.abigdreamer.com/index.php/archives/26 /** * @class Browser 判断浏览器类型和
使用 UE 打开 class 文件,第一行内容: 00000000h: CA FE BA BE 00 00 00 32 00 A9 07 00 02 01 00
这与《【HTML】根据不同的浏览器类型写不同的HTML代码》(点击打开链接)一文是姊妹篇,IE注释能够
该脚本用来访问一个url,并取出相应结果(该脚本用来通过淘宝API实现判断一个IP所在地) 1 #定义要
版权所有 IT知识库 CopyRight © 2009-2015 IT知识库 IT610.com , All Rights Reserved. 京ICP备09083238号